﻿Class Palette : Implements Api.Palette
    ' プラグインを読み込んだクラスから呼ばれてボタン登録 / ボタンにはTabletにCommandを登録するCommandを登録する
    Sub Regist(ByVal button As Button)
        Debug.Print("Regist:" & button.Text)
        Me.Controls.Add(button)
        AddHandler button.Click, AddressOf ButtonX_Click
    End Sub
    ' ボタン押してInvoke
    ' Panelを提供

    Private Sub ButtonX_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Debug.Print("Click:" & DirectCast(sender, Button).Text)
        Dim button As Button = sender
        Dim new_commands As List(Of Api.Command) = DirectCast(button.Tag, List(Of Object)).Item(App.Button_Commands)
        Dim new_strokes As List(Of Api.StrokeModifier) = DirectCast(button.Tag, List(Of Object)).Item(App.Button_Strokes)

        ' TODO:Invoker化
        With Me
            Dim tablet = WindowsApplication1.Tablet.Instance("tablet2")
            Dim invoker = New DrawFreehandLine(tablet)
            If new_commands.Count > 0 Then
                Dim commands = New List(Of Api.Command)
                Dim enu = new_commands.GetEnumerator()
                Do While enu.MoveNext()
                    commands.Add(enu.Current)
                Loop
                tablet.Commands(invoker.GetType()) = commands
            End If
            If new_strokes.Count > 0 Then
                tablet.StrokeModifier(invoker.GetType()) = new_strokes(0)
            End If
        End With
    End Sub

End Class
