﻿Imports System.Drawing

Namespace Brushes

    Public Class ベタブラシ : Inherits Plugin.Brush
        Public Overrides Property Image(ByVal point As Api.StrokePoint) As System.Drawing.Image
            Get
                Dim i = New Bitmap(CType(Math.Round(100 * point.Pressure * 1.1, 0), Integer) + 1, CType(Math.Round(100 * point.Pressure * 1.1, 0), Integer) + 1)

                Dim g = Graphics.FromImage(i)
                g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality

                Dim bound = i.GetBounds(GraphicsUnit.Pixel)
                bound.Inflate(-i.Width * 0.1, -i.Height * 0.1)
                g.FillEllipse(Drawing.Brushes.DarkSlateGray, bound)

                g.Dispose()

                Image = i

                Me._separation = ((i.Width + i.Height) / 2) * 0.2
            End Get
            Set(ByVal value As System.Drawing.Image)
                Me._image = value
            End Set
        End Property

        Public Sub New()
            Me._image = Nothing
            Me._separation = 1
        End Sub
    End Class

End Namespace

Namespace Commands

    Public Class ベタブラシで描画 : Inherits Plugin.Command
        Public Overrides Sub Invoke(ByVal env As Api.Invoker)
            Dim b = New Plugin.Brushes.ベタブラシ
            b.Draw(env.Canvas, env.StrokePoints)
        End Sub
    End Class

End Namespace